Name: coreutils
Version: 5.97
Release: alt6
%define srcname %name-%version

Summary: The GNU versions of common management utilities
License: GPL
Group: System/Base
Url: http://www.gnu.org/software/coreutils/
Packager: Dmitry V. Levin <ldv@altlinux.org>

# ftp://ftp.gnu.org/gnu/coreutils/%srcname.tar.bz2
# ftp://alpha.gnu.org/gnu/coreutils/%srcname.tar.bz2
Source: %srcname.tar
Source1: coreutils-ru.po

# sources from fileutils
Source11: color_ls.sh
Source12: color_ls.csh

# sources from sh-utils
Source20: exit.c
Source21: getuseruid.c
Source22: realpath.c
Source23: runas.c
Source24: runbg.c
Source25: usleep.c
Source26: runas.1
Source27: usleep.1
Source28: true.1
Source29: false.1

# ALT patches, candidates for upstream version
# and CVS backports.
Patch0: coreutils-5.97-cvs-20060628.patch
Patch1: coreutils-5.91-up-ls-usage.patch
Patch2: coreutils-5.91-eggert-ls-time-style.patch
Patch3: coreutils-5.97-up-cut.patch
Patch4: coreutils-5.97-up-copy_internal.patch
Patch5: coreutils-5.97-up-newhashes.patch
Patch6: coreutils-5.97-up-getpwd-openat.patch
Patch7: coreutils-5.91-alt-hostname.patch

# ALT/Owl specific.
Patch101: coreutils-5.92-owl-info-true-false.patch
Patch102: coreutils-5.91-alt-mksock.patch
Patch103: coreutils-5.91-alt-owl-dircolors.patch
Patch104: coreutils-5.3.0-alt-without-su-uptime.patch
Patch105: coreutils-5.3.1-alt-ls-dir-vdir.patch
Patch106: coreutils-5.91-alt-posix2_version.patch

# RH.
Patch202: coreutils-5.2.0-rh-install_strip.patch
Patch203: coreutils-5.3.1-rh-owl-alt-ls_dumbterm.patch
Patch204: coreutils-5.91-rh-alt-langinfo.patch
Patch205: coreutils-5.97-rh-cifs.patch
Patch206: coreutils-5.2.0-rh-alt-ls-stat.patch
Patch207: coreutils-5.97-rh-remove_cwd_entries.patch

Provides: /bin/cat /bin/cut /bin/du /bin/head /bin/hostname /bin/install
Provides: /bin/mkfifo /bin/readlink /bin/sort /bin/tail /bin/wc
Provides: /sbin/chroot
Provides: %_bindir/mksock %_bindir/realpath

Provides: stat = %version, fileutils = %version, textutils = %version, sh-utils = %version
Obsoletes: stat, fileutils, textutils, sh-utils
Conflicts: man-pages < 0:1.52-alt2, initscripts < 0:5.49-ipl41mdk, rpm-build < 0:4.0.4-alt7
# due to /bin/kill
Conflicts: util-linux < 0:2.12-alt1
# due to /usr/bin/kill and %_man1dir/kill.1
Conflicts: procps < 0:2.0.10-alt4
# due to incompatible change in "readlink -f"
Conflicts: chrooted < 0:0.3.1-alt1
# due to buggy rpmdups/rpmrdups
Conflicts: rpm-utils < 0:0.7.6-alt1
# due to hostname
Conflicts: net-tools < 0:1.60-alt9

Requires(post): %install_info
Requires(preun): %uninstall_info

# due to autopoint
BuildPreReq: cvs

# due to ls
BuildRequires: libtinfo-devel

# due to exit.c
BuildRequires: glibc-devel-static

%description
These are the GNU core utilities.  This package is the union of
the GNU fileutils, sh-utils, and textutils packages.

These tools are the GNU versions of common useful and popular
file and text utilities which are used for:
+ file management
+ shell scripting
+ modifying text file

Most of these programs have significant advantages over their Unix
counterparts, such as greater speed, additional options, and fewer
arbitrary limits.

%prep
%setup -q -n %srcname
install -pm644 %_sourcedir/coreutils-ru.po po/ru.po

# ALT patches, candidates for upstream version
# and CVS backports.
%patch0 -p0
%patch1 -p0
%patch2 -p0
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p0
%patch7 -p1

# ALT specific.
%patch101 -p1
%patch102 -p1
%patch103 -p1
%patch104 -p1
%patch105 -p1
%patch106 -p1

# RH.
%patch202 -p1
%patch203 -p1
%patch204 -p1
%patch205 -p1
#FIXME#%patch206 -p1
%patch207 -p1

find -type f -name \*.orig -delete

# Get rid of su and uptime.
rm {src,man}/{su,uptime}.*

# "dist_" is redundant, as sources are distributed by default.
%__subst 's/dist_man_MANS/man_MANS/g' man/Makefile.am

# Docs should say /var/run/[uw]tmp, not /etc/[uw]tmp.
grep -Zl /etc/[uw]tmp doc/* man/* |
	xargs -r0 %__subst -p 's,/etc/utmp,/var/run/utmp,g;s,/etc/wtmp,/var/log/wtmp,g'

# rm -f for easy CVS vs release builds.
rm -f doc/*.info* man/*.1

# Stable autoconf is sufficient to build coreutils for GNU/Linux.
grep -lZ 'AC_PREREQ(2\.59[^)]\+)' m4/*.m4 |
	xargs -r0 %__subst 's/AC_PREREQ(2\.59[^)]\+)/AC_PREREQ(2.59)/' --

bzip2 -9k ChangeLog NEWS THANKS

%build
autoreconf -fisv

# hack to disable uptime build.
export gnulib_cv_have_boot_time=no

%configure --exec-prefix=/
make -C po update-po
%make_build

: ${SHELL:=/bin/sh} ${VERBOSE:=no}
export SHELL VERBOSE
%{?!__buildreqs:%{?!_without_check:%{?!_disable_check:%make_build -k check}}}

# Build our version of true and false.
%__cc %optflags -W -U_FORTIFY_SOURCE -fno-stack-protector -static \
	-nostartfiles -nodefaultlibs -nostdlib %_sourcedir/exit.c \
	-DSTATUS=0 -o true
%__cc %optflags -W -U_FORTIFY_SOURCE -fno-stack-protector -static \
	-nostartfiles -nodefaultlibs -nostdlib %_sourcedir/exit.c \
	-DSTATUS=1 -o false

# Build additional utilities.
for n in getuseruid realpath runas runbg usleep; do
	%__cc %optflags "%_sourcedir/$n.c" -o $n
done

%install
%makeinstall
install -pD -m644 src/dircolors.hin "%buildroot%_sysconfdir/DIR_COLORS"

pushd "%buildroot"
	mkdir -p bin
	
	# %_bindir -> /bin relocations
        for n in \
		basename cat chgrp chmod chown cp cut date dd df du echo \
		false head hostname install kill link ln ls mkdir mkfifo \
		mknod mv nice pwd readlink rm rmdir sleep sort stty sync \
		tail touch true uname unlink wc \
	; do
		mv .%_bindir/$n bin/
	done

	# dir and vdir now symlinks to ls
	ln -snf ../../bin/ls .%_bindir/dir
	ln -snf ../../bin/ls .%_bindir/vdir

	# compatibility symlinks
	for n in cat cut du head install kill mkfifo sort tail wc; do
		ln -s ../../bin/$n .%_bindir/
	done

	# test
	ln -snf test .%_bindir/[

	# chroot
	mkdir -p sbin .%_sbindir
	mv .%_bindir/chroot sbin/
		ln -s ../../sbin/chroot .%_sbindir/

	# hostname
	for n in dnsdomainname domainname nisdomainname ypdomainname; do
		ln -s hostname ./bin/$n
		ln -s hostname.1 ./%_man1dir/$n.1
	done

	mkdir -p .%_sysconfdir/profile.d
	install -pm755 %_sourcedir/color_ls.{sh,csh} .%_sysconfdir/profile.d/
	ln -s ../../bin/install .%_bindir/ginstall
popd

# Install assembler versions of true and false and their manpages.
install -pm755 true false %buildroot/bin/
install -pm644 %_sourcedir/{true,false}.1 %buildroot%_mandir/man1/

# Install additional utilities and their manpages.
install -pm755 getuseruid runas usleep %buildroot/bin/
install -pm755 realpath runbg %buildroot%_bindir/
install -pm644 %_sourcedir/{runas,usleep}.1 %buildroot%_man1dir/

%find_lang %name

%pre
# Remove info pages from fileutils, textutils and sh-utils.
for f in %_infodir/{fileutils,textutils,sh-utils}.info*; do
	[ -f "$f" ] || continue
	RPM_INSTALL_ARG1=0 %_sbindir/uninstall_info "$f" ||:
done

%post
%install_info %name.info

%preun
%uninstall_info %name.info

%files -f %name.lang
%config(noreplace) %_sysconfdir/DIR_COLORS
%config(noreplace) %_sysconfdir/profile.d/*
/bin/*
%_bindir/*
/sbin/*
%_sbindir/*
%_mandir/man?/*
%_infodir/*.info*
%doc AUTHORS ChangeLog.bz2 NEWS.bz2 README THANKS.bz2 TODO

%changelog
* Tue May 22 2007 Dmitry V. Levin <ldv@altlinux.org> 5.97-alt6
- Reverted recent ls "fix" (#11740).

* Tue Apr 17 2007 Dmitry V. Levin <ldv@altlinux.org> 5.97-alt5
- Backported upstream fix for "ls --indicator-style=file-type" (RH#230052).
- Import coreutils-5.97-rh-remove_cwd_entries.patch (RH#235401).

* Tue Apr 10 2007 Dmitry V. Levin <ldv@altlinux.org> 5.97-alt4
- color_ls.sh: Quoted $TERM (#11440).
- color_ls.csh: Synced with color_ls.sh

* Sat Feb 03 2007 Dmitry V. Levin <ldv@altlinux.org> 5.97-alt3
- Fixed getcwd() to make pwd(1) and readlink(1) work also
  when run with an unreadable parent dir on systems with
  openat(2) support (Jim Meyering, fixes RH#227168).

* Fri Feb 02 2007 Dmitry V. Levin <ldv@altlinux.org> 5.97-alt2
- Updated to b5_9x snapshot 20060628.
- true, false: Rewritten without using glibc.
- Fixed a double-free bug in cut (Jim Meyering, fixes RH#220312).
- Fixed mv(1) error reporting (Jim Meyering, fixes DEB#376749).
- Backported new hashes: base64, sha224sum sha256sum sha384sum sha512sum.
- Added cifs to df(1) remote filesystems list (FC, fixes RH#183703).

* Sun Jun 25 2006 Dmitry V. Levin <ldv@altlinux.org> 5.97-alt1
- Updated to 5.97.

* Sat May 27 2006 Dmitry V. Levin <ldv@altlinux.org> 5.96-alt2
- Backported chgrp fix from 5_94 branch.
- Rewritten assembler version of true and false in C to avoid
  portability issues.

* Mon May 22 2006 Dmitry V. Levin <ldv@altlinux.org> 5.96-alt1
- Updated to 5.96.

* Tue May 16 2006 Dmitry V. Levin <ldv@altlinux.org> 5.95-alt1
- Updated to 5.95.

* Wed Apr 05 2006 Dmitry V. Levin <ldv@altlinux.org> 5.94-alt2
- Added .note.GNU-stack to exit.S.

* Wed Feb 15 2006 Dmitry V. Levin <ldv@altlinux.org> 5.94-alt1
- Updated to 5.94.
- Updated russian translation.

* Fri Feb 03 2006 Dmitry V. Levin <ldv@altlinux.org> 5.93-alt2
- Backported fts fixes from 5_94 branch.

* Mon Nov 07 2005 Dmitry V. Levin <ldv@altlinux.org> 5.93-alt1
- Updated to 5.93.

* Sat Nov 05 2005 Dmitry V. Levin <ldv@altlinux.org> 5.92-alt4
- Updated to 20051102 snapshot from stable 5_9x branch.

* Thu Oct 27 2005 Dmitry V. Levin <ldv@altlinux.org> 5.92-alt3
- md5sum: Changed default read mode back to text, to sync
  with documentation and for backwards compatibility.

* Mon Oct 24 2005 Dmitry V. Levin <ldv@altlinux.org> 5.92-alt2
- mkdir -p, install -d: When creating final component
  of the file name, do not fail when it already exists.

* Sun Oct 23 2005 Dmitry V. Levin <ldv@altlinux.org> 5.92-alt1
- Updated to 5.92.

* Thu Oct 20 2005 Dmitry V. Levin <ldv@altlinux.org> 5.91-alt1
- Updated to 5.91.
- Replaced rh-owl-ls_default_time_style patch with
  eggert-ls-time-style patch.
- Removed already disabled rh-owl-install-C patch.
- Reviewed and updated alt-posix2_version patch.
- Fixed 'ls --help' output (Eric Blake, closes #8176).
- Updated russian translation (closes #7628, #7633)

* Mon Apr 25 2005 Dmitry V. Levin <ldv@altlinux.org> 5.3.1-alt0.4
- Updated to 5.3.1 snapshot 200504240446.
- Updated mksock and ls_dir_vdir patches to use
  program_invocation_short_name instead of __progname.

* Wed Apr 13 2005 Dmitry V. Levin <ldv@altlinux.org> 5.3.1-alt0.3
- Updated to 5.3.1 snapshot 200504120741.

* Mon Apr 11 2005 Dmitry V. Levin <ldv@altlinux.org> 5.3.1-alt0.2
- Relocated chroot utility from %_sbindir to /sbin.
- Packaged hostname(1) (#6360).
- Patched hostname(1) to be somewhat compatible with
  traditional hostname utility from net-tools package.

* Mon Apr 04 2005 Dmitry V. Levin <ldv@altlinux.org> 5.3.1-alt0.1
- Updated to 5.3.1 snapshot 200504010740.
- tee: do not close stdout more than once.

* Tue Jan 11 2005 Dmitry V. Levin <ldv@altlinux.org> 5.3.0-alt1
- Updated to 5.3.0 snapshot 200501082045 (release).

* Sun Jan 02 2005 Dmitry V. Levin <ldv@altlinux.org> 5.3.0-alt0.10
- Updated to 5.3.0 snapshot 200412311006.

* Sat Nov 20 2004 Dmitry V. Levin <ldv@altlinux.org> 5.3.0-alt0.9
- Updated to 5.3.0 snapshot 200411200857.

* Mon Nov 01 2004 Dmitry V. Levin <ldv@altlinux.org> 5.3.0-alt0.8
- Updated to 5.3.0 snapshot 200410292210.

* Sun Oct 17 2004 Dmitry V. Levin <ldv@altlinux.org> 5.3.0-alt0.7
- Updated to 5.3.0 snapshot 200410151932.

* Thu Sep 30 2004 Dmitry V. Levin <ldv@altlinux.org> 5.3.0-alt0.6
- Updated to 5.3.0 snapshot 200409280634.

* Tue Aug 24 2004 Dmitry V. Levin <ldv@altlinux.org> 5.3.0-alt0.5
- Updated to 5.3.0 snapshot 200408240736.

* Mon Aug 23 2004 Dmitry V. Levin <ldv@altlinux.org> 5.3.0-alt0.4
- Updated to 5.3.0 snapshot 200408200229.

* Fri Aug 13 2004 Dmitry V. Levin <ldv@altlinux.org> 5.3.0-alt0.3
- chown: Fixed USER.GROUP bug.

* Thu Aug 12 2004 Dmitry V. Levin <ldv@altlinux.org> 5.3.0-alt0.2
- Updated to 5.3.0 snapshot 200408112347.
- install: Fixed one more regression.
- exit.S: Added x86_64 support.

* Tue Aug 10 2004 Dmitry V. Levin <ldv@altlinux.org> 5.3.0-alt0.1
- Updated to 5.3.0 snapshot 200408100654.
- Merged upstream: 7 patches.
- Reworked patches.
- install: Fixed two regressions.

* Thu Jun 03 2004 Dmitry V. Levin <ldv@altlinux.org> 5.2.1-alt5
- Fixed canonicalize_file_name behaviour.
- Changed default behaviour for chown/chgrp.

* Sun Apr 25 2004 Dmitry V. Levin <ldv@altlinux.org> 5.2.1-alt4
- Backported "stty -iutf8" option support.
  Requires quite fresh glibc-devel package at build time.

* Sun Apr 04 2004 Dmitry V. Levin <ldv@altlinux.org> 5.2.1-alt3
- readlink: implemented more canonicalize options.

* Wed Mar 31 2004 Dmitry V. Levin <ldv@altlinux.org> 5.2.1-alt2
- Assorted backports from cvs head.
- Package /bin/kill, %_bindir/kill and its manpage from coreutils.

* Sat Mar 13 2004 Dmitry V. Levin <ldv@altlinux.org> 5.2.1-alt1
- Updated to 5.2.1
- Merged upstream patches:
  eggert-chown-lsb
  alt-cloexec

* Tue Mar 02 2004 Dmitry V. Levin <ldv@altlinux.org> 5.2.0-alt2
- chown: applied patch from Paul Eggert, see
  http://mail.gnu.org/archive/html/bug-coreutils/2004-02/msg00125.html
- nohup: fixed nasty fd leak.

* Mon Feb 23 2004 Dmitry V. Levin <ldv@altlinux.org> 5.2.0-alt1
- Updated to 5.2.0, reviewed patches.
- Merged upstream patches:
  alt-owl-chown
- Removed obsolete patches:
  rh-CLOCK_REALTIME
  rh-df_spacedir
  rh-mem
  rh-utmp
- Added RH patches:
  rh-afs
  rh-langinfo
  rh-allow_old_options
  rh-alt-ls-stat
- Use tweaked help2man from this package for manpage generation.
- Do not build and package rm-static.

* Tue Jun 03 2003 Dmitry V. Levin <ldv@altlinux.org> 5.0-alt3
- Fixed file descriptor leakage in du (Jim Meyering).
- Build statically linked version of the GNU rm program
  and package it into rm-static subpackage.

* Fri May 02 2003 Dmitry V. Levin <ldv@altlinux.org> 5.0-alt2
- Regenerated manpages with help2man-1.29-alt2.
- Ported %%pre script to new uninstall_info.

* Sun Apr 06 2003 Dmitry V. Levin <ldv@altlinux.org> 5.0-alt1
- Updated to 5.0

* Mon Mar 31 2003 Dmitry V. Levin <ldv@altlinux.org> 4.5.12-alt1
- Updated to 4.5.12

* Thu Mar 20 2003 Dmitry V. Levin <ldv@altlinux.org> 4.5.11-alt1
- Updated to 4.5.11

* Fri Mar 14 2003 Dmitry V. Levin <ldv@altlinux.org> 4.5.10-alt1
- Updated to 4.5.10

* Wed Mar 05 2003 Dmitry V. Levin <ldv@altlinux.org> 4.5.9-alt1
- Updated to 4.5.9

* Sat Feb 22 2003 Dmitry V. Levin <ldv@altlinux.org> 4.5.8-alt1
- Updated to 4.5.8

* Mon Feb 10 2003 Dmitry V. Levin <ldv@altlinux.org> 4.5.7-alt1
- Updated to 4.5.7
- Updated patches:
  + alt-texinfo

* Thu Feb 06 2003 Dmitry V. Levin <ldv@altlinux.org> 4.5.6-alt1
- Updated to 4.5.6
- Merged upstream patches:
  + alt-who_xmalloc_fix
- Updated patches:
  + alt-texinfo

* Tue Feb 04 2003 Dmitry V. Levin <ldv@altlinux.org> 4.5.5-alt1
- Updated to 4.5.5
- Merged upstream patches:
  + alt-xalloc
  + alt-xgetcwd
  + alt-canonicalize
  + alt-readlink
  + alt-owl-rh-ls_restore_color
- New patches:
  + alt-xalloc
- Updated patches:
  + alt-mksock
  + alt-without-hostname-su-uptime

* Tue Feb 04 2003 Dmitry V. Levin <ldv@altlinux.org> 4.5.3-alt3
- who: fixed memory allocation arithmetic (#0002149).

* Sun Dec 01 2002 Dmitry V. Levin <ldv@altlinux.org> 4.5.3-alt2
- Removed automake patch (no longer needed with automake >= 1.7).
- Minor code cleanups (xalloc and xgetcwd).
- Added canonicalize_file_name implementation to libfetish;
  affects non-glibc platforms.
- Turned dir and vdir into symlinks to ls (#0001635).
- Updated dircolors.
- Removed obsolete (merged) patches:
  sh-utils-2.0-rh-rfc822
- Removed obsolete (not applied) patches:
  fileutils-4.0.38-alt-cp_deref_always
  fileutils-4.1-alt-cp_force_ignore
- Rediffed patches:
  rh-df_spacedir
  rh-install_strip
  rh-owl-alt-ls_dumbterm
  rh-CLOCK_REALTIME
  alt-owl-chown
- Corrected description.

* Thu Oct 31 2002 Dmitry V. Levin <ldv@altlinux.org> 4.5.3-alt1
- Updated to 4.5.3
- Our "ln --target-dir" fix merged upstream.

* Sun Oct 13 2002 Dmitry V. Levin <ldv@altlinux.org> 4.5.2-alt2
- Minor specfile tweaks.
- Updated buildrequires.

* Tue Oct 08 2002 Dmitry V. Levin <ldv@altlinux.org> 4.5.2-alt1
- Updated to 4.5.2
- Disabled cp_deref_always patch.
- Enabled tests by default.
- Fixed "ln --target-dir" (#0001369).

* Thu Sep 26 2002 Stanislav Ievlev <inger@altlinux.ru> 4.5.1-alt2
- Ressurected Conflicts.

* Tue Sep 17 2002 Stanislav Ievlev <inger@altlinux.ru> 4.5.1-alt1
- Inital build for ALT. This package is the union of the
  fileutils, sh-utils, and textutils packages.
- Review patches:
  + dropped "rh-stoneage" patch;
  + adopted readlink and mksock patches;
  + disabled "force interactive" patch.
